# Copyright 2019 the V8 project authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can
# be found in the LICENSE file.

# This file is automatically generated by mkgrokdump and should not
# be modified manually.

# List of known V8 instance types.
INSTANCE_TYPES = {
  0: "INTERNALIZED_STRING_TYPE",
  2: "EXTERNAL_INTERNALIZED_STRING_TYPE",
  8: "ONE_BYTE_INTERNALIZED_STRING_TYPE",
  10: "EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  18: "UNCACHED_EXTERNAL_INTERNALIZED_STRING_TYPE",
  26: "UNCACHED_EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  32: "STRING_TYPE",
  33: "CONS_STRING_TYPE",
  34: "EXTERNAL_STRING_TYPE",
  35: "SLICED_STRING_TYPE",
  37: "THIN_STRING_TYPE",
  40: "ONE_BYTE_STRING_TYPE",
  41: "CONS_ONE_BYTE_STRING_TYPE",
  42: "EXTERNAL_ONE_BYTE_STRING_TYPE",
  43: "SLICED_ONE_BYTE_STRING_TYPE",
  45: "THIN_ONE_BYTE_STRING_TYPE",
  50: "UNCACHED_EXTERNAL_STRING_TYPE",
  58: "UNCACHED_EXTERNAL_ONE_BYTE_STRING_TYPE",
  64: "SYMBOL_TYPE",
  65: "HEAP_NUMBER_TYPE",
  66: "BIGINT_TYPE",
  67: "ODDBALL_TYPE",
  68: "MAP_TYPE",
  69: "CODE_TYPE",
  70: "FOREIGN_TYPE",
  71: "BYTE_ARRAY_TYPE",
  72: "BYTECODE_ARRAY_TYPE",
  73: "FREE_SPACE_TYPE",
  74: "FIXED_DOUBLE_ARRAY_TYPE",
  75: "FEEDBACK_METADATA_TYPE",
  76: "FILLER_TYPE",
  77: "ACCESS_CHECK_INFO_TYPE",
  78: "ACCESSOR_INFO_TYPE",
  79: "ACCESSOR_PAIR_TYPE",
  80: "ALIASED_ARGUMENTS_ENTRY_TYPE",
  81: "ALLOCATION_MEMENTO_TYPE",
  82: "ARRAY_BOILERPLATE_DESCRIPTION_TYPE",
  83: "ASM_WASM_DATA_TYPE",
  84: "ASYNC_GENERATOR_REQUEST_TYPE",
  85: "CLASS_POSITIONS_TYPE",
  86: "DEBUG_INFO_TYPE",
  87: "ENUM_CACHE_TYPE",
  88: "FUNCTION_TEMPLATE_INFO_TYPE",
  89: "FUNCTION_TEMPLATE_RARE_DATA_TYPE",
  90: "INTERCEPTOR_INFO_TYPE",
  91: "INTERPRETER_DATA_TYPE",
  92: "OBJECT_TEMPLATE_INFO_TYPE",
  93: "PROMISE_CAPABILITY_TYPE",
  94: "PROMISE_REACTION_TYPE",
  95: "PROTOTYPE_INFO_TYPE",
  96: "SCRIPT_TYPE",
  97: "SOURCE_POSITION_TABLE_WITH_FRAME_CACHE_TYPE",
  98: "SOURCE_TEXT_MODULE_INFO_ENTRY_TYPE",
  99: "STACK_FRAME_INFO_TYPE",
  100: "STACK_TRACE_FRAME_TYPE",
  101: "TEMPLATE_OBJECT_DESCRIPTION_TYPE",
  102: "TUPLE2_TYPE",
  103: "TUPLE3_TYPE",
  104: "WASM_CAPI_FUNCTION_DATA_TYPE",
  105: "WASM_DEBUG_INFO_TYPE",
  106: "WASM_EXCEPTION_TAG_TYPE",
  107: "WASM_EXPORTED_FUNCTION_DATA_TYPE",
  108: "WASM_INDIRECT_FUNCTION_TABLE_TYPE",
  109: "WASM_JS_FUNCTION_DATA_TYPE",
  110: "CALLABLE_TASK_TYPE",
  111: "CALLBACK_TASK_TYPE",
  112: "PROMISE_FULFILL_REACTION_JOB_TASK_TYPE",
  113: "PROMISE_REJECT_REACTION_JOB_TASK_TYPE",
  114: "PROMISE_RESOLVE_THENABLE_JOB_TASK_TYPE",
  115: "INTERNAL_CLASS_TYPE",
  116: "SMI_PAIR_TYPE",
  117: "SMI_BOX_TYPE",
  118: "SORT_STATE_TYPE",
  119: "SOURCE_TEXT_MODULE_TYPE",
  120: "SYNTHETIC_MODULE_TYPE",
  121: "ALLOCATION_SITE_TYPE",
  122: "EMBEDDER_DATA_ARRAY_TYPE",
  123: "FIXED_ARRAY_TYPE",
  124: "OBJECT_BOILERPLATE_DESCRIPTION_TYPE",
  125: "CLOSURE_FEEDBACK_CELL_ARRAY_TYPE",
  126: "HASH_TABLE_TYPE",
  127: "ORDERED_HASH_MAP_TYPE",
  128: "ORDERED_HASH_SET_TYPE",
  129: "ORDERED_NAME_DICTIONARY_TYPE",
  130: "NAME_DICTIONARY_TYPE",
  131: "GLOBAL_DICTIONARY_TYPE",
  132: "NUMBER_DICTIONARY_TYPE",
  133: "SIMPLE_NUMBER_DICTIONARY_TYPE",
  134: "STRING_TABLE_TYPE",
  135: "EPHEMERON_HASH_TABLE_TYPE",
  136: "SCOPE_INFO_TYPE",
  137: "SCRIPT_CONTEXT_TABLE_TYPE",
  138: "AWAIT_CONTEXT_TYPE",
  139: "BLOCK_CONTEXT_TYPE",
  140: "CATCH_CONTEXT_TYPE",
  141: "DEBUG_EVALUATE_CONTEXT_TYPE",
  142: "EVAL_CONTEXT_TYPE",
  143: "FUNCTION_CONTEXT_TYPE",
  144: "MODULE_CONTEXT_TYPE",
  145: "NATIVE_CONTEXT_TYPE",
  146: "SCRIPT_CONTEXT_TYPE",
  147: "WITH_CONTEXT_TYPE",
  148: "WEAK_FIXED_ARRAY_TYPE",
  149: "TRANSITION_ARRAY_TYPE",
  150: "CALL_HANDLER_INFO_TYPE",
  151: "CELL_TYPE",
  152: "CODE_DATA_CONTAINER_TYPE",
  153: "DESCRIPTOR_ARRAY_TYPE",
  154: "FEEDBACK_CELL_TYPE",
  155: "FEEDBACK_VECTOR_TYPE",
  156: "LOAD_HANDLER_TYPE",
  157: "PREPARSE_DATA_TYPE",
  158: "PROPERTY_ARRAY_TYPE",
  159: "PROPERTY_CELL_TYPE",
  160: "SHARED_FUNCTION_INFO_TYPE",
  161: "SMALL_ORDERED_HASH_MAP_TYPE",
  162: "SMALL_ORDERED_HASH_SET_TYPE",
  163: "SMALL_ORDERED_NAME_DICTIONARY_TYPE",
  164: "STORE_HANDLER_TYPE",
  165: "UNCOMPILED_DATA_WITHOUT_PREPARSE_DATA_TYPE",
  166: "UNCOMPILED_DATA_WITH_PREPARSE_DATA_TYPE",
  167: "WEAK_ARRAY_LIST_TYPE",
  168: "WEAK_CELL_TYPE",
  1024: "JS_PROXY_TYPE",
  1025: "JS_GLOBAL_OBJECT_TYPE",
  1026: "JS_GLOBAL_PROXY_TYPE",
  1027: "JS_MODULE_NAMESPACE_TYPE",
  1040: "JS_SPECIAL_API_OBJECT_TYPE",
  1041: "JS_PRIMITIVE_WRAPPER_TYPE",
  1056: "JS_API_OBJECT_TYPE",
  1057: "JS_OBJECT_TYPE",
  1058: "JS_ARGUMENTS_TYPE",
  1059: "JS_ARRAY_BUFFER_TYPE",
  1060: "JS_ARRAY_ITERATOR_TYPE",
  1061: "JS_ARRAY_TYPE",
  1062: "JS_ASYNC_FROM_SYNC_ITERATOR_TYPE",
  1063: "JS_ASYNC_FUNCTION_OBJECT_TYPE",
  1064: "JS_ASYNC_GENERATOR_OBJECT_TYPE",
  1065: "JS_CONTEXT_EXTENSION_OBJECT_TYPE",
  1066: "JS_DATE_TYPE",
  1067: "JS_ERROR_TYPE",
  1068: "JS_GENERATOR_OBJECT_TYPE",
  1069: "JS_MAP_TYPE",
  1070: "JS_MAP_KEY_ITERATOR_TYPE",
  1071: "JS_MAP_KEY_VALUE_ITERATOR_TYPE",
  1072: "JS_MAP_VALUE_ITERATOR_TYPE",
  1073: "JS_MESSAGE_OBJECT_TYPE",
  1074: "JS_PROMISE_TYPE",
  1075: "JS_REGEXP_TYPE",
  1076: "JS_REGEXP_STRING_ITERATOR_TYPE",
  1077: "JS_SET_TYPE",
  1078: "JS_SET_KEY_VALUE_ITERATOR_TYPE",
  1079: "JS_SET_VALUE_ITERATOR_TYPE",
  1080: "JS_STRING_ITERATOR_TYPE",
  1081: "JS_WEAK_REF_TYPE",
  1082: "JS_FINALIZATION_GROUP_CLEANUP_ITERATOR_TYPE",
  1083: "JS_FINALIZATION_GROUP_TYPE",
  1084: "JS_WEAK_MAP_TYPE",
  1085: "JS_WEAK_SET_TYPE",
  1086: "JS_TYPED_ARRAY_TYPE",
  1087: "JS_DATA_VIEW_TYPE",
  1088: "JS_INTL_V8_BREAK_ITERATOR_TYPE",
  1089: "JS_INTL_COLLATOR_TYPE",
  1090: "JS_INTL_DATE_TIME_FORMAT_TYPE",
  1091: "JS_INTL_LIST_FORMAT_TYPE",
  1092: "JS_INTL_LOCALE_TYPE",
  1093: "JS_INTL_NUMBER_FORMAT_TYPE",
  1094: "JS_INTL_PLURAL_RULES_TYPE",
  1095: "JS_INTL_RELATIVE_TIME_FORMAT_TYPE",
  1096: "JS_INTL_SEGMENT_ITERATOR_TYPE",
  1097: "JS_INTL_SEGMENTER_TYPE",
  1098: "WASM_EXCEPTION_TYPE",
  1099: "WASM_GLOBAL_TYPE",
  1100: "WASM_INSTANCE_TYPE",
  1101: "WASM_MEMORY_TYPE",
  1102: "WASM_MODULE_TYPE",
  1103: "WASM_TABLE_TYPE",
  1104: "JS_BOUND_FUNCTION_TYPE",
  1105: "JS_FUNCTION_TYPE",
}

# List of known V8 maps.
KNOWN_MAPS = {
  ("read_only_space", 0x00121): (73, "FreeSpaceMap"),
  ("read_only_space", 0x00169): (68, "MetaMap"),
  ("read_only_space", 0x001e1): (67, "NullMap"),
  ("read_only_space", 0x00241): (153, "DescriptorArrayMap"),
  ("read_only_space", 0x00299): (148, "WeakFixedArrayMap"),
  ("read_only_space", 0x002e1): (76, "OnePointerFillerMap"),
  ("read_only_space", 0x00329): (76, "TwoPointerFillerMap"),
  ("read_only_space", 0x003a1): (67, "UninitializedMap"),
  ("read_only_space", 0x00409): (8, "OneByteInternalizedStringMap"),
  ("read_only_space", 0x004a1): (67, "UndefinedMap"),
  ("read_only_space", 0x004f9): (65, "HeapNumberMap"),
  ("read_only_space", 0x00571): (67, "TheHoleMap"),
  ("read_only_space", 0x00611): (67, "BooleanMap"),
  ("read_only_space", 0x006e1): (71, "ByteArrayMap"),
  ("read_only_space", 0x00729): (123, "FixedArrayMap"),
  ("read_only_space", 0x00771): (123, "FixedCOWArrayMap"),
  ("read_only_space", 0x007b9): (126, "HashTableMap"),
  ("read_only_space", 0x00801): (64, "SymbolMap"),
  ("read_only_space", 0x00849): (40, "OneByteStringMap"),
  ("read_only_space", 0x00891): (136, "ScopeInfoMap"),
  ("read_only_space", 0x008d9): (160, "SharedFunctionInfoMap"),
  ("read_only_space", 0x00921): (69, "CodeMap"),
  ("read_only_space", 0x00969): (143, "FunctionContextMap"),
  ("read_only_space", 0x009b1): (151, "CellMap"),
  ("read_only_space", 0x009f9): (159, "GlobalPropertyCellMap"),
  ("read_only_space", 0x00a41): (70, "ForeignMap"),
  ("read_only_space", 0x00a89): (149, "TransitionArrayMap"),
  ("read_only_space", 0x00ad1): (155, "FeedbackVectorMap"),
  ("read_only_space", 0x00b69): (67, "ArgumentsMarkerMap"),
  ("read_only_space", 0x00c01): (67, "ExceptionMap"),
  ("read_only_space", 0x00c99): (67, "TerminationExceptionMap"),
  ("read_only_space", 0x00d39): (67, "OptimizedOutMap"),
  ("read_only_space", 0x00dd1): (67, "StaleRegisterMap"),
  ("read_only_space", 0x00e39): (145, "NativeContextMap"),
  ("read_only_space", 0x00e81): (144, "ModuleContextMap"),
  ("read_only_space", 0x00ec9): (142, "EvalContextMap"),
  ("read_only_space", 0x00f11): (146, "ScriptContextMap"),
  ("read_only_space", 0x00f59): (138, "AwaitContextMap"),
  ("read_only_space", 0x00fa1): (139, "BlockContextMap"),
  ("read_only_space", 0x00fe9): (140, "CatchContextMap"),
  ("read_only_space", 0x01031): (147, "WithContextMap"),
  ("read_only_space", 0x01079): (141, "DebugEvaluateContextMap"),
  ("read_only_space", 0x010c1): (137, "ScriptContextTableMap"),
  ("read_only_space", 0x01109): (125, "ClosureFeedbackCellArrayMap"),
  ("read_only_space", 0x01151): (75, "FeedbackMetadataArrayMap"),
  ("read_only_space", 0x01199): (123, "ArrayListMap"),
  ("read_only_space", 0x011e1): (66, "BigIntMap"),
  ("read_only_space", 0x01229): (124, "ObjectBoilerplateDescriptionMap"),
  ("read_only_space", 0x01271): (72, "BytecodeArrayMap"),
  ("read_only_space", 0x012b9): (152, "CodeDataContainerMap"),
  ("read_only_space", 0x01301): (74, "FixedDoubleArrayMap"),
  ("read_only_space", 0x01349): (131, "GlobalDictionaryMap"),
  ("read_only_space", 0x01391): (154, "ManyClosuresCellMap"),
  ("read_only_space", 0x013d9): (123, "ModuleInfoMap"),
  ("read_only_space", 0x01421): (130, "NameDictionaryMap"),
  ("read_only_space", 0x01469): (154, "NoClosuresCellMap"),
  ("read_only_space", 0x014b1): (132, "NumberDictionaryMap"),
  ("read_only_space", 0x014f9): (154, "OneClosureCellMap"),
  ("read_only_space", 0x01541): (127, "OrderedHashMapMap"),
  ("read_only_space", 0x01589): (128, "OrderedHashSetMap"),
  ("read_only_space", 0x015d1): (129, "OrderedNameDictionaryMap"),
  ("read_only_space", 0x01619): (157, "PreparseDataMap"),
  ("read_only_space", 0x01661): (158, "PropertyArrayMap"),
  ("read_only_space", 0x016a9): (150, "SideEffectCallHandlerInfoMap"),
  ("read_only_space", 0x016f1): (150, "SideEffectFreeCallHandlerInfoMap"),
  ("read_only_space", 0x01739): (150, "NextCallSideEffectFreeCallHandlerInfoMap"),
  ("read_only_space", 0x01781): (133, "SimpleNumberDictionaryMap"),
  ("read_only_space", 0x017c9): (123, "SloppyArgumentsElementsMap"),
  ("read_only_space", 0x01811): (161, "SmallOrderedHashMapMap"),
  ("read_only_space", 0x01859): (162, "SmallOrderedHashSetMap"),
  ("read_only_space", 0x018a1): (163, "SmallOrderedNameDictionaryMap"),
  ("read_only_space", 0x018e9): (119, "SourceTextModuleMap"),
  ("read_only_space", 0x01931): (134, "StringTableMap"),
  ("read_only_space", 0x01979): (120, "SyntheticModuleMap"),
  ("read_only_space", 0x019c1): (165, "UncompiledDataWithoutPreparseDataMap"),
  ("read_only_space", 0x01a09): (166, "UncompiledDataWithPreparseDataMap"),
  ("read_only_space", 0x01a51): (167, "WeakArrayListMap"),
  ("read_only_space", 0x01a99): (135, "EphemeronHashTableMap"),
  ("read_only_space", 0x01ae1): (122, "EmbedderDataArrayMap"),
  ("read_only_space", 0x01b29): (168, "WeakCellMap"),
  ("read_only_space", 0x01b71): (58, "NativeSourceStringMap"),
  ("read_only_space", 0x01bb9): (32, "StringMap"),
  ("read_only_space", 0x01c01): (41, "ConsOneByteStringMap"),
  ("read_only_space", 0x01c49): (33, "ConsStringMap"),
  ("read_only_space", 0x01c91): (45, "ThinOneByteStringMap"),
  ("read_only_space", 0x01cd9): (37, "ThinStringMap"),
  ("read_only_space", 0x01d21): (35, "SlicedStringMap"),
  ("read_only_space", 0x01d69): (43, "SlicedOneByteStringMap"),
  ("read_only_space", 0x01db1): (34, "ExternalStringMap"),
  ("read_only_space", 0x01df9): (42, "ExternalOneByteStringMap"),
  ("read_only_space", 0x01e41): (50, "UncachedExternalStringMap"),
  ("read_only_space", 0x01e89): (0, "InternalizedStringMap"),
  ("read_only_space", 0x01ed1): (2, "ExternalInternalizedStringMap"),
  ("read_only_space", 0x01f19): (10, "ExternalOneByteInternalizedStringMap"),
  ("read_only_space", 0x01f61): (18, "UncachedExternalInternalizedStringMap"),
  ("read_only_space", 0x01fa9): (26, "UncachedExternalOneByteInternalizedStringMap"),
  ("read_only_space", 0x01ff1): (58, "UncachedExternalOneByteStringMap"),
  ("read_only_space", 0x02039): (67, "SelfReferenceMarkerMap"),
  ("read_only_space", 0x02099): (87, "EnumCacheMap"),
  ("read_only_space", 0x02131): (82, "ArrayBoilerplateDescriptionMap"),
  ("read_only_space", 0x02319): (90, "InterceptorInfoMap"),
  ("read_only_space", 0x04c51): (77, "AccessCheckInfoMap"),
  ("read_only_space", 0x04c99): (78, "AccessorInfoMap"),
  ("read_only_space", 0x04ce1): (79, "AccessorPairMap"),
  ("read_only_space", 0x04d29): (80, "AliasedArgumentsEntryMap"),
  ("read_only_space", 0x04d71): (81, "AllocationMementoMap"),
  ("read_only_space", 0x04db9): (83, "AsmWasmDataMap"),
  ("read_only_space", 0x04e01): (84, "AsyncGeneratorRequestMap"),
  ("read_only_space", 0x04e49): (85, "ClassPositionsMap"),
  ("read_only_space", 0x04e91): (86, "DebugInfoMap"),
  ("read_only_space", 0x04ed9): (88, "FunctionTemplateInfoMap"),
  ("read_only_space", 0x04f21): (89, "FunctionTemplateRareDataMap"),
  ("read_only_space", 0x04f69): (91, "InterpreterDataMap"),
  ("read_only_space", 0x04fb1): (92, "ObjectTemplateInfoMap"),
  ("read_only_space", 0x04ff9): (93, "PromiseCapabilityMap"),
  ("read_only_space", 0x05041): (94, "PromiseReactionMap"),
  ("read_only_space", 0x05089): (95, "PrototypeInfoMap"),
  ("read_only_space", 0x050d1): (96, "ScriptMap"),
  ("read_only_space", 0x05119): (97, "SourcePositionTableWithFrameCacheMap"),
  ("read_only_space", 0x05161): (98, "SourceTextModuleInfoEntryMap"),
  ("read_only_space", 0x051a9): (99, "StackFrameInfoMap"),
  ("read_only_space", 0x051f1): (100, "StackTraceFrameMap"),
  ("read_only_space", 0x05239): (101, "TemplateObjectDescriptionMap"),
  ("read_only_space", 0x05281): (102, "Tuple2Map"),
  ("read_only_space", 0x052c9): (103, "Tuple3Map"),
  ("read_only_space", 0x05311): (104, "WasmCapiFunctionDataMap"),
  ("read_only_space", 0x05359): (105, "WasmDebugInfoMap"),
  ("read_only_space", 0x053a1): (106, "WasmExceptionTagMap"),
  ("read_only_space", 0x053e9): (107, "WasmExportedFunctionDataMap"),
  ("read_only_space", 0x05431): (108, "WasmIndirectFunctionTableMap"),
  ("read_only_space", 0x05479): (109, "WasmJSFunctionDataMap"),
  ("read_only_space", 0x054c1): (110, "CallableTaskMap"),
  ("read_only_space", 0x05509): (111, "CallbackTaskMap"),
  ("read_only_space", 0x05551): (112, "PromiseFulfillReactionJobTaskMap"),
  ("read_only_space", 0x05599): (113, "PromiseRejectReactionJobTaskMap"),
  ("read_only_space", 0x055e1): (114, "PromiseResolveThenableJobTaskMap"),
  ("read_only_space", 0x05629): (115, "InternalClassMap"),
  ("read_only_space", 0x05671): (116, "SmiPairMap"),
  ("read_only_space", 0x056b9): (117, "SmiBoxMap"),
  ("read_only_space", 0x05701): (118, "SortStateMap"),
  ("read_only_space", 0x05749): (121, "AllocationSiteWithWeakNextMap"),
  ("read_only_space", 0x05791): (121, "AllocationSiteWithoutWeakNextMap"),
  ("read_only_space", 0x057d9): (156, "LoadHandler1Map"),
  ("read_only_space", 0x05821): (156, "LoadHandler2Map"),
  ("read_only_space", 0x05869): (156, "LoadHandler3Map"),
  ("read_only_space", 0x058b1): (164, "StoreHandler0Map"),
  ("read_only_space", 0x058f9): (164, "StoreHandler1Map"),
  ("read_only_space", 0x05941): (164, "StoreHandler2Map"),
  ("read_only_space", 0x05989): (164, "StoreHandler3Map"),
  ("map_space", 0x00121): (1057, "ExternalMap"),
  ("map_space", 0x00169): (1073, "JSMessageObjectMap"),
}

# List of known V8 objects.
KNOWN_OBJECTS = {
  ("read_only_space", 0x001b1): "NullValue",
  ("read_only_space", 0x00229): "EmptyDescriptorArray",
  ("read_only_space", 0x00289): "EmptyWeakFixedArray",
  ("read_only_space", 0x00371): "UninitializedValue",
  ("read_only_space", 0x00471): "UndefinedValue",
  ("read_only_space", 0x004e9): "NanValue",
  ("read_only_space", 0x00541): "TheHoleValue",
  ("read_only_space", 0x005d1): "HoleNanValue",
  ("read_only_space", 0x005e1): "TrueValue",
  ("read_only_space", 0x00689): "FalseValue",
  ("read_only_space", 0x006d1): "empty_string",
  ("read_only_space", 0x00b19): "EmptyScopeInfo",
  ("read_only_space", 0x00b29): "EmptyFixedArray",
  ("read_only_space", 0x00b39): "ArgumentsMarker",
  ("read_only_space", 0x00bd1): "Exception",
  ("read_only_space", 0x00c69): "TerminationException",
  ("read_only_space", 0x00d09): "OptimizedOut",
  ("read_only_space", 0x00da1): "StaleRegister",
  ("read_only_space", 0x02081): "EmptyEnumCache",
  ("read_only_space", 0x020e1): "EmptyPropertyArray",
  ("read_only_space", 0x020f1): "EmptyByteArray",
  ("read_only_space", 0x02101): "EmptyObjectBoilerplateDescription",
  ("read_only_space", 0x02119): "EmptyArrayBoilerplateDescription",
  ("read_only_space", 0x02179): "EmptyClosureFeedbackCellArray",
  ("read_only_space", 0x02189): "EmptySloppyArgumentsElements",
  ("read_only_space", 0x021a9): "EmptySlowElementDictionary",
  ("read_only_space", 0x021f1): "EmptyOrderedHashMap",
  ("read_only_space", 0x02219): "EmptyOrderedHashSet",
  ("read_only_space", 0x02241): "EmptyFeedbackMetadata",
  ("read_only_space", 0x02251): "EmptyPropertyCell",
  ("read_only_space", 0x02279): "EmptyPropertyDictionary",
  ("read_only_space", 0x022c9): "NoOpInterceptorInfo",
  ("read_only_space", 0x02361): "EmptyWeakArrayList",
  ("read_only_space", 0x02379): "InfinityValue",
  ("read_only_space", 0x02389): "MinusZeroValue",
  ("read_only_space", 0x02399): "MinusInfinityValue",
  ("read_only_space", 0x023a9): "SelfReferenceMarker",
  ("read_only_space", 0x02401): "OffHeapTrampolineRelocationInfo",
  ("read_only_space", 0x02419): "TrampolineTrivialCodeDataContainer",
  ("read_only_space", 0x02431): "TrampolinePromiseRejectionCodeDataContainer",
  ("read_only_space", 0x02449): "GlobalThisBindingScopeInfo",
  ("read_only_space", 0x024b1): "EmptyFunctionScopeInfo",
  ("read_only_space", 0x02501): "HashSeed",
  ("old_space", 0x00121): "ArgumentsIteratorAccessor",
  ("old_space", 0x00191): "ArrayLengthAccessor",
  ("old_space", 0x00201): "BoundFunctionLengthAccessor",
  ("old_space", 0x00271): "BoundFunctionNameAccessor",
  ("old_space", 0x002e1): "ErrorStackAccessor",
  ("old_space", 0x00351): "FunctionArgumentsAccessor",
  ("old_space", 0x003c1): "FunctionCallerAccessor",
  ("old_space", 0x00431): "FunctionNameAccessor",
  ("old_space", 0x004a1): "FunctionLengthAccessor",
  ("old_space", 0x00511): "FunctionPrototypeAccessor",
  ("old_space", 0x00581): "RegExpResultIndicesAccessor",
  ("old_space", 0x005f1): "StringLengthAccessor",
  ("old_space", 0x00661): "InvalidPrototypeValidityCell",
  ("old_space", 0x00671): "EmptyScript",
  ("old_space", 0x006f1): "ManyClosuresCell",
  ("old_space", 0x00709): "ArrayConstructorProtector",
  ("old_space", 0x00731): "NoElementsProtector",
  ("old_space", 0x00759): "IsConcatSpreadableProtector",
  ("old_space", 0x00781): "ArraySpeciesProtector",
  ("old_space", 0x007a9): "TypedArraySpeciesProtector",
  ("old_space", 0x007d1): "PromiseSpeciesProtector",
  ("old_space", 0x007f9): "StringLengthProtector",
  ("old_space", 0x00821): "ArrayIteratorProtector",
  ("old_space", 0x00849): "ArrayBufferDetachingProtector",
  ("old_space", 0x00871): "PromiseHookProtector",
  ("old_space", 0x00899): "PromiseResolveProtector",
  ("old_space", 0x008c1): "MapIteratorProtector",
  ("old_space", 0x008e9): "PromiseThenProtector",
  ("old_space", 0x00911): "SetIteratorProtector",
  ("old_space", 0x00939): "StringIteratorProtector",
  ("old_space", 0x00961): "SingleCharacterStringCache",
  ("old_space", 0x01171): "StringSplitCache",
  ("old_space", 0x01981): "RegExpMultipleCache",
  ("old_space", 0x02191): "BuiltinsConstantsTable",
}

# List of known V8 Frame Markers.
FRAME_MARKERS = (
  "ENTRY",
  "CONSTRUCT_ENTRY",
  "EXIT",
  "OPTIMIZED",
  "WASM_COMPILED",
  "WASM_TO_JS",
  "JS_TO_WASM",
  "WASM_INTERPRETER_ENTRY",
  "C_WASM_ENTRY",
  "WASM_EXIT",
  "WASM_COMPILE_LAZY",
  "INTERPRETED",
  "STUB",
  "BUILTIN_CONTINUATION",
  "JAVA_SCRIPT_BUILTIN_CONTINUATION",
  "JAVA_SCRIPT_BUILTIN_CONTINUATION_WITH_CATCH",
  "INTERNAL",
  "CONSTRUCT",
  "ARGUMENTS_ADAPTOR",
  "BUILTIN",
  "BUILTIN_EXIT",
  "NATIVE",
)

# This set of constants is generated from a shipping build.
